
class NullAcquest:
    def acquire (self, name, default = None):
        #print 'acquire from top'
        return default

    def getAcquisitionList (self, name, all = None):
        return []

_defaultTop = NullAcquest ()

class Acquest:
    def __init__ (self, context = None):
        if context == None:
            context = _defaultTop
        self.acquisitionContext = context

    def setContext (self, context):
        assert not (self is context)
        self.acquisitionContext = context

    def acquire (self, name, default = None):
        #print '<acquire name="%s" self="%s">' % (name, self)
        try:
            result = getattr (self, name)
            #print 'acquire', name, 'in', self
        except AttributeError:
            try:
                context = self.acquisitionContext
            except AttributeError:
                print 'no context in', self
            #try:
            result = self.acquisitionContext.acquire (name, default)
            #except AttributeError:
            #    result = default
        #print '</acquire>'
        return result

    def lockAcquisitions (self, *names):
        for name in names:
            value = self.acquire (name)
            setattr (self, name, value)

    def promoteContext (self, *acquisitions):
        for acquisition in acquisitions:
            # print 'promote acquisition from', self, 'to', acquisition
            assert not (self is acquisition)
            acquisition.acquisitionContext = self


    def getAcquisitionList (self, name, all = None):
        definesIt = hasattr (self, name)
        if all or not definesIt:
            upstream = self.acquisitionContext.getAcquisitionList (name, all)
        else:
            upstream = []
        if definesIt:
            value = getattr (self, name)
        else:
            value = None
        upstream.append ((value, self))
        return upstream

    def printAcquisitionList (self, name, all = None):
        list = self.getAcquisitionList (name, all)
        print 'occurrences of', name
        for value, obj in list:
            print '   ', value, obj

