
import cStringIO

class RE_Filter:
    def __init__ (self, reCallbackPairs):
        self.pairs = reCallbackPairs

    def filterFile (self, fname):
        data = open (fname, 'rt').read ()
        newdata = self.filter (data)
        hasChanged = (data != newdata)
        if hasChanged:
            open (fname, 'wt').write (newdata)
        return hasChanged

    def filter (self, data):
        pos = 0
        dataLen = len (data)
        outstream = cStringIO.StringIO ()
        reStates = self.buildInitialState (data)
        self.buildNextState (reStates, data, pos)
        matchStart, match, expr, callback = reStates [0]
        while matchStart < dataLen:
            outstream.write (data [pos:matchStart])
            pos, replacement = callback (match, data)
            outstream.write (replacement)
            self.buildNextState (reStates, data, pos)
            matchStart, match, expr, callback = reStates [0]
        outstream.write (data [pos:])
        return outstream.getvalue ()

    def buildInitialState (self, data):
        reStates = []
        for expr, callback in self.pairs:
            state = (-1, None, expr, callback)
            reStates.append (state)
        return reStates

    def buildNextState (self, reStates, data, pos):
        for i in xrange (len (reStates)):
            matchStart, match, expr, callback = reStates [i]
            if matchStart >= pos:
                # assumimg a sorted list
                # the remaining matches are still valid
                break
            match = expr.search (data, pos)
            if match:
                state = (match.start (), match, expr, callback)
            else:
                state = (len (data), None, expr, callback)
            reStates [i] = state
        reStates.sort ()

