"""undiffLib.py     remove std diffs from diff output
"""

from string import strip
import re

change   = '[0-9]+(,[0-9]+)?c[0-9]+(,[0-9]+)?'
addition = '[0-9]+(,[0-9]+)?a[0-9]+(,[0-9]+)?'
deletion = '[0-9]+(,[0-9]+)?d[0-9]+(,[0-9]+)?'
_emptyAdd = addition + '(\n>)+'
_emptyDel = deletion + '(\n<)+'

class Undiffer:
    def __init__ (self, pdiff):
        self.pdiff = pdiff
        self.data = open (pdiff, 'r').read ()

    def write (self):
        open (self.pdiff, 'w').write (strip (self.data))

    def removeAll (self, pattern):
        self.data = re.sub (pattern, '', self.data)

    def removeConditional (self, condition, pattern):
        self.data = re.sub (pattern,
            CondToReplacement (condition).replace,
            self.data)

    def removeEmptyLines (self):
        self.removeAll (_emptyAdd)
        self.removeAll (_emptyDel)

    def runSafe (self, callable):
        try:
            callable (self)
        except:
            import traceback, sys
            errfile = open (self.pdiff, 'a')
            traceback.print_exc (10, errfile)
            errfile.close ()
            sys.exit (5)

class CondToReplacement:
    def __init__ (self, condition):
        self.condition = condition

    def replace (self, match):
        if self.condition (match):
            result = ''
        else:
            result = match.group (0)
        return result

